/*
********************************************************************
(c) MSU Video Group 2003-2006, http://compression.ru/video/
This source code is property of MSU Graphics and Media Lab

This code may be distributed under LGPL
(see http://www.gnu.org/licenses/lgpl.html for more details).

E-mail: video-measure@compression.ru
Author: Oleg Petrov
********************************************************************
*/  

#pragma once

#include "icustomplugin.h"

/*
*	Adapts your plugin that is derived from ICustomPlugin to IMetricPlugin
*/
class CPluginAdapter : public IMetricPlugin
{
private:
	ICustomPlugin *m_plugin;

public:
	CPluginAdapter(ICustomPlugin *plugin);	// must get valid pointer to your custom plugin;
	~CPluginAdapter();	// deletes plugin after all job is done.

	/*	All functions below are from IMetricPlugin interface*/
	void	Init(IMetricPlugin::COLORCOMPONENT cc, int width, int height, int &global_id);
	void	Measure(IMetricImage **images, int images_num, ID *ids, float *res, int &res_num);
	void	MeasureAndVisualize(IMetricImage **images, int images_num, ID *ids, float *res, int &res_num, BYTE *visualization, int visualization_pitch);
	void	MapIDToFrame(int &ids_num, ID * ids, int **frames, wchar_t **names, bool visualize);
	void	CalculateAverage(ID *ids, float *res, int &res_num, bool visualize);
	int		GetVideoNum(bool visualize);
	void	GetSupportedColorcomponents(COLORCOMPONENT *cc, int &cc_num);
	void	GetName(wchar_t *name);
	void	GetUnit(wchar_t *name);
	int		GetWidthMultiply();
	int		GetHeightMultiply();
	void	GetInterfaceName(wchar_t *interface_name);
	void	GetMetrInfoURL(wchar_t *info_url);
	bool	GetMetrIncline();
	bool	IsConfigurable();
	bool	Config(const wchar_t* configuration_line);
	bool	GetDefaultConfiguration(wchar_t* buf, int buf_size);
	int		GetVersion();
};
